//Sieve of Eratosthenes. Stock Standard C++ Code. Useful for "Large Prime Variation" Page 480. Remark 2 "A Course In Computational Algebriac Number Theory" H.Cohen.
//That is (x1x2/p)^2 = F1F2(mod N) which is a useful relation ! Where F does not factor completely and p is a large Prime.
//Warren

#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

void Era_prime_sieve(vector <bool>& sieve, int N)
{
    // mark address 0 and 1 as false, not primes
    sieve[0] = sieve[1] = false;

    //set even numbers as false starting at Trial Division 4
    for (int i = 4; i < N; i += 2)
        sieve[i] = false;

    //set multiples of all odd numbers as false
    for (int i = 3; i < N; i += 2)
        for (int j = i * i; j < N; j += i)
            sieve[j] = false;
}

void Primes_Vac1(vector <int>& primes, vector <bool> sieve)
{
    primes.push_back(2);
    for (int i = 3; i < sieve.size(); i += 2)
        if (sieve[i])
            primes.push_back(i);

    return;
}

void print_factors(vector <int> factors)
{
    cout << "Prime factors are:" << endl;
    for (int eta : factors)
        cout << eta << " ";
    cout << endl;
}

void Prime_factors(vector <int> primes, int N)
{
    vector <int> factors;

    int N_new = N;
    int i = 0;
    int p = primes[0];

    while (p * p <= N_new)
    {
        if (N % p == 0)
        {
            factors.push_back(p);

            while (N % p == 0)
                N /= p;
        }

        i++;
        p = primes[i];
    }

 
    if (N != 1)
        factors.push_back(N);

    print_factors(factors);
}

int main()
{
    int BM = 1000;
    vector <bool> sieve(BM, true);
    Era_prime_sieve(sieve, BM);

    vector <int> primes;
    Primes_Vac1(primes, sieve);

    cout << "Enter the number" << endl;
    int N;
    cin >> N;

    Prime_factors(primes, N);

    return 0;
}